{include file='modules/servers/puqPowerDNS/templates/header.tpl'}
{if $message}
    {if $message == 'success'}
        <div class="alert alert-success text-center">
            {$dns->lang['Successfully']}
        </div>
    {else}
        <div class="alert alert-danger text-center">
            {$message}
        </div>
    {/if}
{/if}

<div class="form-group text-center">
    <a href="{$dns->SystemURL}/clientarea.php?action=productdetails&id={$dns->service_id}" class="btn btn-default">
        <i class="fas fa-backward"></i>
        {$dns->lang['All DNS Zones']}
    </a>

    <button data-toggle="modal" data-target="#addRecordModal" class="btn btn-success">
        <i class="fas fa-plus"></i>
        {$dns->lang['Add Record']}
    </button>

    <a href="{$dns->SystemURL}/clientarea.php?action=productdetails&id={$dns->service_id}&zone_id={$dns->zoneDB->id}&reload=yes"
       class="btn btn-warning"
       onclick="showLoader()">
        <i class="fal fa-sync"></i>
        {$dns->lang['Reload DNS Zone']}
    </a>

</div>

<div class="card">
    <div class="card-header">
        <h2>{$dns->zoneDB->zone}</h2>
    </div>
    <div class="card-body p-0">
        {foreach $dns->zoneDB->rrsets as $rrset}
            {if $rrset['type'] == "SOA"}
                {foreach $rrset['records'] as $record}
                    <div class="row border-bottom m-0 py-2 align-items-center">
                        <div class="col-1 text-center">
                            <i class="fa fa-server"></i>
                        </div>
                        <div class="col-1">
                            <strong>{$dns->lang['SOA']}</strong>
                        </div>
                        <div class="col-{if $dns->package_option_edit_soa == 'yes'}9{else}10{/if}">
                            {$record['content']}
                        </div>

                        {if $dns->package_option_edit_soa == 'yes'}
                            <div class="col-1">
                                <button class="btn btn-warning btn-sm edit-record-btn" title="{$dns->lang['Edit']}"
                                        data-toggle="modal"
                                        data-target="#editRecordModal"
                                        data-type="{$rrset['type']}"
                                        data-name="{$rrset['name']|regex_replace:"/\.$/":""}"
                                        data-ttl="{$rrset['ttl']}"
                                        data-content="{$record['content']|base64_encode}"
                                        data-json="{$record['json']}">
                                    <i class="fa fa-edit"></i>
                                </button>
                            </div>
                        {/if}
                    </div>
                {/foreach}

            {/if}
        {/foreach}

        {foreach $dns->zoneDB->rrsets as $rrset}
            {if $rrset['type'] == "NS"}
                {foreach $rrset['records'] as $record}
                    <div class="row border-bottom m-0 py-2 align-items-center">
                        <div class="col-1 text-center">
                            <i class="fa fa-server"></i>
                        </div>
                        <div class="col-2">
                            <strong>{$dns->lang['NS']}</strong>
                        </div>
                        <div class="col-9">
                            {$record['content']|regex_replace:"/\.$/":""}
                        </div>
                    </div>
                {/foreach}

            {/if}
        {/foreach}

    </div>
</div>

<table id="records" class="display table table-list dataTable no-footer" style="width:100%">
    <thead>
    <tr>
        <th>{$dns->lang['Type']}</th>
        <th>{$dns->lang['Name']}</th>
        <th>{$dns->lang['Content']}</th>
        <th>{$dns->lang['TTL']}</th>
        <th>{$dns->lang['Actions']}</th>
    </tr>
    </thead>
    <tbody>

    {foreach $dns->zoneDB->rrsets as $rrset}
        {if $rrset['type'] != "NS" AND $rrset['type'] != "SOA"}
            {foreach $rrset['records'] as $record}
                <tr>
                    <td class="text-center" style="max-width: 30px;">{$rrset['type']}</td>
                    <td class="text-truncate" style="max-width: 100px;">{$rrset['name']|regex_replace:"/\.$/":""}</td>
                    <td class="text-truncate" style="max-width: 150px;">{$record['content']}</td>
                    <td>{$rrset['ttl']}</td>
                    <td class="text-center">
                        <button class="btn btn-warning btn-sm edit-record-btn" title="{$dns->lang['Edit']}"
                                data-toggle="modal"
                                data-target="#editRecordModal"
                                data-type="{$rrset['type']}"
                                data-name="{$rrset['name']|regex_replace:"/\.$/":""}"
                                data-ttl="{$rrset['ttl']}"
                                data-content="{$record['content']|base64_encode}"
                                data-json="{$record['json']}">
                            <i class="fa fa-edit"></i>
                        </button>
                        <button class="btn btn-danger btn-sm ml-2" title="{$dns->lang['Delete']}"
                                data-toggle="modal"
                                data-target="#confirmDeleteModal"
                                data-type="{$rrset['type']}"
                                data-name="{$rrset['name']}"
                                data-content="{$record['content']|base64_encode}">
                            <i class="fa fa-trash"></i>
                        </button>
                    </td>
                </tr>
            {/foreach}
        {/if}
    {/foreach}

    </tbody>
</table>

<div class="modal fade" id="confirmDeleteModal" tabindex="-1" role="dialog" aria-labelledby="confirmDeleteModalLabel"
     aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="confirmDeleteModalLabel">{$dns->lang['Confirm Delete']}</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                {$dns->lang['Are you sure you want to delete the record?']}
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                    {$dns->lang['Cancel']}
                </button>
                <button type="button" class="btn btn-danger" id="confirmDeleteBtn">
                    <i class="fa fa-times"></i> {$dns->lang['Delete']}
                </button>
            </div>
        </div>
    </div>
</div>

<script>
    $(document).ready(function () {
        $('#records').DataTable({
            responsive: true,
            "paging": true,
            "info": false,
            "lengthMenu": [[50, 100, 200, 500], [50, 100, 200, 500]],
            "pageLength": 50,
            "language": {
                "decimal": "",
                "emptyTable": "{$dns->lang['No data available in table']}",
                "info": "{$dns->lang['Showing _START_ to _END_ of _TOTAL_ entries']}",
                "infoEmpty": "{$dns->lang['Showing 0 entries']}",
                "infoFiltered": "{$dns->lang['(filtered from _MAX_ total entries)']}",
                "infoPostFix": "",
                "thousands": ",",
                "lengthMenu": "{$dns->lang['Show _MENU_ entries']}",
                "loadingRecords": "{$dns->lang['Loading...']}",
                "processing": "{$dns->lang['Processing...']}",
                "search": "{$dns->lang['Search:']}",
                "zeroRecords": "{$dns->lang['No matching records found']}",
                "paginate": {
                    "first": "{$dns->lang['First']}",
                    "last": "{$dns->lang['Last']}",
                    "next": "{$dns->lang['Next']}",
                    "previous": "{$dns->lang['Previous']}"
                },
                "aria": {
                    "sortAscending": "{$dns->lang[': activate to sort column ascending']}",
                    "sortDescending": "{$dns->lang[': activate to sort column descending']}"
                }
            }
        });
    });

    $('#confirmDeleteModal').on('show.bs.modal', function (event) {
        var button = $(event.relatedTarget);
        var type = button.data('type');
        var name = button.data('name');
        var content = button.data('content');
        var modal = $(this);


        modal.find('#confirmDeleteBtn').off('click').on('click', function () {
            showLoader();
            $.ajax({
                url: '{$url}',
                type: 'POST',
                data: {
                    ajax: 'deleteRecord',
                    type: type,
                    name: name,
                    content: content
                },
                success: function (response) {
                    window.location.reload();
                },
                error: function (error) {
                    hideLoader();
                    alert('{$dns->lang['An error occurred while deleting the item']}');
                }
            });
        });
    });

    {literal}
    function updateDynamicFields(dynamicFieldsContainer, recordType, existingData = {}) {
        dynamicFieldsContainer.innerHTML = "";

        let fieldsHTML = getFieldsHTML(recordType, existingData);

        dynamicFieldsContainer.innerHTML = fieldsHTML;
    }

    function getFieldsHTML(recordType, existingData) {
        switch (recordType) {
            case "SOA":
                return getSOAFieldsHTML(existingData);
            case "A":
                return getAFieldsHTML(existingData);
            case "AAAA":
                return getAAAAFieldsHTML(existingData);
            case "MX":
                return getMXFieldsHTML(existingData);
            case "CNAME":
                return getCNAMEFieldsHTML(existingData);
            case "TXT":
                return getTXTFieldsHTML(existingData);
            case "SRV":
                return getSRVFieldsHTML(existingData);
            case "PTR":
                return getPTRFieldsHTML(existingData);
            case "CAA":
                return getCAAFieldsHTML(existingData);
            case "DNSKEY":
                return getDNSKEYFieldsHTML(existingData);
            case "DS":
                return getDSFieldsHTML(existingData);
            case "NAPTR":
                return getNAPTRFieldsHTML(existingData);
            case "TLSA":
                return getTLSAFieldsHTML(existingData);
            default:
                return `<div class="form-group"><p>{/literal}{$dns->lang['No fields available for this record type.']}{literal}</p></div>`;
        }
    }

    function getSOAFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="email">{/literal}{$dns->lang['Zone Administrator Email']}{literal}</label>
            <input type="text" class="form-control" id="email" name="email" value="${existingData.email || ''}" required>
        </div>
        <div class="form-group col-md-12">
            <label for="refresh">{/literal}{$dns->lang['Refresh Interval']}{literal}</label>
            <input type="number" min="1" class="form-control" id="refresh" name="refresh" value="${existingData.refresh || ''}" required>
        </div>
        <div class="form-group col-md-12">
            <label for="retry">{/literal}{$dns->lang['Retry Interval']}{literal}</label>
            <input type="number" min="1" class="form-control" id="retry" name="retry" value="${existingData.retry || ''}" required>
        </div>
        <div class="form-group col-md-12">
            <label for="expire">{/literal}{$dns->lang['Expiration Time']}{literal}</label>
            <input type="number" min="1" class="form-control" id="expire" name="expire" value="${existingData.expire || ''}" required>
        </div>
        <div class="form-group col-md-12">
            <label for="minimum">{/literal}{$dns->lang['Minimum TTL']}{literal}</label>
            <input type="number" min="1" class="form-control" id="minimum" name="minimum" value="${existingData.minimum || ''}" required>
        </div>`;
    }

    function getAFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="ipv4">{/literal}{$dns->lang['IPv4 address (required)']}{literal}</label>
            <input type="text" class="form-control" id="ipv4" name="ipv4" value="${existingData.ipv4 || ''}" required>
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. 192.168.0.1']}{literal}</small>
        </div>`;
    }

    function getAAAAFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="ipv6">{/literal}{$dns->lang['IPv6 address (required)']}{literal}</label>
            <input type="text" class="form-control" id="ipv6" name="ipv6" value="${existingData.ipv6 || ''}" required>
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. 2001:0db8:85a3:0000:0000:8a2e:0370:7334']}{literal}</small>
        </div>`;
    }

    function getMXFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-8">
            <label for="mailServer">{/literal}{$dns->lang['Mail server (required)']}{literal}</label>
            <input type="text" class="form-control" id="mailServer" name="mailServer" value="${existingData.mailServer || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. mx1.example.com']}{literal}</small>
        </div>
        <div class="form-group col-md-4">
            <label for="priority">{/literal}{$dns->lang['Priority (required)']}{literal}</label>
            <input type="number" min="0" max="65535" step="1" class="form-control" id="priority" name="priority" value="${existingData.priority || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 65535']}{literal}</small>
        </div>`;
    }

    function getCNAMEFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="target">{/literal}{$dns->lang['Target (required)']}{literal}</label>
            <input type="text" class="form-control" id="target" name="target" value="${existingData.target || ''}" required>
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. www.example.com']}{literal}</small>
        </div>`;
    }

    function getTXTFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="content">{/literal}{$dns->lang['Content (required)']}{literal}</label>
            <textarea class="form-control" id="content" name="content" rows="5" required>${existingData.content || ''}</textarea>
        </div>`;
    }

    function getSRVFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-4">
            <label for="priority">{/literal}{$dns->lang['Priority (required)']}{literal}</label>
            <input type="number" min="0" max="65535" step="1" class="form-control" id="priority" name="priority" value="${existingData.priority || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 65535']}{literal}</small>
        </div>
        <div class="form-group col-md-4">
            <label for="weight">{/literal}{$dns->lang['Weight (required)']}{literal}</label>
            <input type="number" min="0" max="65535" step="1" class="form-control" id="weight" name="weight" value="${existingData.weight || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 65535']}{literal}</small>
        </div>
        <div class="form-group col-md-4">
            <label for="port">{/literal}{$dns->lang['Port (required)']}{literal}</label>
            <input type="number" min="0" max="65535" step="1" class="form-control" id="port" name="port" value="${existingData.port || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 65535']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="target">{/literal}{$dns->lang['Target (required)']}{literal}</label>
            <textarea class="form-control" id="target" name="target" rows="3" required>${existingData.target || ''}</textarea>
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. www.example.com']}{literal}</small>
        </div>`;
    }

    function getPTRFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="target">{/literal}{$dns->lang['Domain name (required)']}{literal}</label>
            <input type="text" class="form-control" id="target" name="target" value="${existingData.target || ''}" required>
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. www.example.com']}{literal}</small>
        </div>`;
    }

    function getNSFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="nameServer">{/literal}{$dns->lang['Name server (required)']}{literal}</label>
            <input type="text" class="form-control" id="nameServer" name="nameServer" value="${existingData.nameServer || ''}" required>
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. ns1.example.com']}{literal}</small>
        </div>`;
    }

    function getCAAFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="flags">{/literal}{$dns->lang['Flags (required)']}{literal}</label>
            <input type="number" min="0" max="255" step="1" class="form-control" id="flags" name="flags" value="${existingData.flags || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 255']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="tag">{/literal}{$dns->lang['Tag (required)']}{literal}</label>
            <input type="text" class="form-control" id="tag" name="tag" value="${existingData.tag || ''}" required>
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. issue, iodef']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="value">{/literal}{$dns->lang['Value (required)']}{literal}</label>
            <input type="text" class="form-control" id="value" name="value" value="${existingData.value || ''}" required>
            <small class="form-text text-muted">{/literal}{$dns->lang['E.g. letsencrypt.org']}{literal}</small>
        </div>`;
    }

    function getDNSKEYFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="flags">{/literal}{$dns->lang['Flags (required)']}{literal}</label>
            <input type="number" min="0" max="65535" step="1" class="form-control" id="flags" name="flags" value="${existingData.flags || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 65535']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="protocol">{/literal}{$dns->lang['Protocol (required)']}{literal}</label>
            <input type="number" min="0" max="255" step="1" class="form-control" id="protocol" name="protocol" value="${existingData.protocol || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 255']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="algorithm">{/literal}{$dns->lang['Algorithm (required)']}{literal}</label>
            <input type="number" min="0" max="255" step="1" class="form-control" id="algorithm" name="algorithm" value="${existingData.algorithm || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 255']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="publicKey">{/literal}{$dns->lang['Public Key (required)']}{literal}</label>
            <textarea class="form-control" id="publicKey" name="publicKey" rows="5" required>${existingData.publicKey || ''}</textarea>
        </div>`;
    }

    function getDSFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-12">
            <label for="keyTag">{/literal}{$dns->lang['Key Tag (required)']}{literal}</label>
            <input type="number" min="0" max="65535" step="1" class="form-control" id="keyTag" name="keyTag" value="${existingData.keyTag || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 65535']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="algorithm">{/literal}{$dns->lang['Algorithm (required)']}{literal}</label>
            <input type="number" min="0" max="255" step="1" class="form-control" id="algorithm" name="algorithm" value="${existingData.algorithm || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 255']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="digestType">{/literal}{$dns->lang['Digest Type (required)']}{literal}</label>
            <input type="number" min="0" max="255" step="1" class="form-control" id="digestType" name="digestType" value="${existingData.digestType || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 255']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="digest">{/literal}{$dns->lang['Digest (required)']}{literal}</label>
            <textarea class="form-control" id="digest" name="digest" rows="5" required>${existingData.digest || ''}</textarea>
        </div>`;
    }

    function getNAPTRFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-4">
            <label for="order">{/literal}{$dns->lang['Order (required)']}{literal}</label>
            <input type="number" min="0" max="65535" step="1" class="form-control" id="order" name="order" value="${existingData.order || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 65535']}{literal}</small>
        </div>
        <div class="form-group col-md-4">
            <label for="preference">{/literal}{$dns->lang['Preference (required)']}{literal}</label>
            <input type="number" min="0" max="65535" step="1" class="form-control" id="preference" name="preference" value="${existingData.preference || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 65535']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="flags">{/literal}{$dns->lang['Flags (required)']}{literal}</label>
            <input type="text" class="form-control" id="flags" name="flags" value="${existingData.flags || ''}" required>
        </div>
        <div class="form-group col-md-12">
            <label for="service">{/literal}{$dns->lang['Service (required)']}{literal}</label>
            <input type="text" class="form-control" id="service" name="service" value="${existingData.service || ''}" required>
        </div>
        <div class="form-group col-md-12">
            <label for="regexp">{/literal}{$dns->lang['Regexp (required)']}{literal}</label>
            <input type="text" class="form-control" id="regexp" name="regexp" value="${existingData.regexp || ''}" required>
        </div>
        <div class="form-group col-md-12">
            <label for="replacement">{/literal}{$dns->lang['Replacement (required)']}{literal}</label>
            <input type="text" class="form-control" id="replacement" name="replacement" value="${existingData.replacement || ''}" required>
        </div>`;
    }

    function getTLSAFieldsHTML(existingData) {
        return `
        <div class="form-group col-md-4">
            <label for="usage">{/literal}{$dns->lang['Usage (required)']}{literal}</label>
            <input type="number" min="0" max="255" step="1" class="form-control" id="usage" name="usage" value="${existingData.usage || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 255']}{literal}</small>
        </div>
        <div class="form-group col-md-4">
            <label for="selector">{/literal}{$dns->lang['Selector (required)']}{literal}</label>
            <input type="number" min="0" max="255" step="1" class="form-control" id="selector" name="selector" value="${existingData.selector || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 255']}{literal}</small>
        </div>
        <div class="form-group col-md-4">
            <label for="matchingType">{/literal}{$dns->lang['Matching Type (required)']}{literal}</label>
            <input type="number" min="0" max="255" step="1" class="form-control" id="matchingType" name="matchingType" value="${existingData.matchingType || ''}">
            <small class="form-text text-muted">{/literal}{$dns->lang['0 - 255']}{literal}</small>
        </div>
        <div class="form-group col-md-12">
            <label for="certificateAssociationData">{/literal}{$dns->lang['Certificate Association Data (required)']}{literal}</label>
            <textarea class="form-control" id="certificateAssociationData" name="certificateAssociationData" rows="5" required>${existingData.certificateAssociationData || ''}</textarea>
        </div>`;
    }

    {/literal}
</script>

{include file='modules/servers/puqPowerDNS/templates/add_record.tpl'}
{include file='modules/servers/puqPowerDNS/templates/edit_record.tpl'}




